/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package Ontologia;

import java.util.*;
import java.io.*;

import com.hp.hpl.jena.ontology.*;
import com.hp.hpl.jena.query.*;
import com.hp.hpl.jena.rdf.model.*;
import com.hp.hpl.jena.util.*;
import com.hp.hpl.jena.graph.*;
import com.hp.hpl.jena.util.iterator.*;
import es.accv.arangi.util.*;


import java.lang.Object;
//import edu.stanford.smi.protegex.*;

/**
 *
 * @author cati
 */
public class Ontologia {
    
    //public OntModel ontmodel = null;
    //public InputStream inst = FileManager.get().open("http://localhost:8084/poblamentOntologia/Twitter.owl");
    
    public String Poblament(String s){
        String str = "";
        
        String prefixClasse = "http://www.owl-ontologies.com/Ontology1380644855.owl";
        String prefixClasseN = prefixClasse + "#";
        
        OntModel ontmodel = null;
        ontmodel = ModelFactory.createOntologyModel(OntModelSpec.OWL_MEM);
        InputStream inst = FileManager.get().open("http://localhost:8084/poblamentOntologia/Twitter.owl");
        if (inst == null){
            throw new IllegalArgumentException("Fitxer no trobat");
        }
              
        ontmodel.read(inst,"");
        com.hp.hpl.jena.util.iterator.ExtendedIterator iteratorClasses = ontmodel.listClasses();
        str = str + MostrarClassesInstanciesActuals(s, iteratorClasses);
        
        str = str + IntroduirInstanciaClasseCoordinates (s, "CoordinatesProva1", ontmodel, "coordinates_1", "type_1");
        str = str + IntroduirInstanciaClasseHashtag (s, "HashtagProva1", ontmodel, "indices_1", "text_1");
        str = str + IntroduirInstanciaClasseMedia (s, "MediaProva1", ontmodel, "display_url_1");
        str = str + IntroduirInstanciaClasseUrl (s, "UrlProva1", ontmodel, "display_url_1");
        str = str + IntroduirInstanciaClasseUserMention (s, "UserMentionProva1", ontmodel, "id_1");
        str = str + IntroduirInstanciaClasseLlista (s, "LlistaProva1", ontmodel, "description_1");
        str = str + IntroduirInstanciaClasseSize (s, "SizeProva1", ontmodel, "h_1", "resize_1", "w_1");
        str = str + IntroduirInstanciaClasseSizes (s, "SizesProva1", ontmodel, "large_1");
        str = str + IntroduirInstanciaClasseTweet (s, "TweetProva1", ontmodel, "created_at_1");
        str = str + IntroduirInstanciaClasseUser (s, "UserProva1", ontmodel, "created_at_1");
        
        com.hp.hpl.jena.util.iterator.ExtendedIterator iteratorClasses2 = ontmodel.listClasses();
        str = str + MostrarClassesInstanciesActuals(s, iteratorClasses2);
        
        ontmodel.close();
        
        return str;
    }
    
    public String MostrarClassesInstanciesActuals(String s,com.hp.hpl.jena.util.iterator.ExtendedIterator iteratorClasses){
        String prefixClasse = "http://www.owl-ontologies.com/Ontology1380644855.owl";
        String prefixClasseN = prefixClasse + "#";
        
        String llistaClasses = "Classes: ";
        String llistaInstancies = "Instàncies: ";
        while (iteratorClasses.hasNext()){
            OntClass ontC = (OntClass) iteratorClasses.next();
            if (ontC.isClass() && ontC.toString().contains(prefixClasseN)){
                llistaClasses = llistaClasses + "\t" + ontC.toString().replace(prefixClasseN, "") + ", ";
            }
            ExtendedIterator iteratorInstancies = ontC.listInstances();
            while (iteratorInstancies.hasNext()){
                llistaInstancies = llistaInstancies + "\t" + iteratorInstancies.next().toString().replace(prefixClasseN, "") + ", ";
            }
        }
        llistaClasses = llistaClasses.replace("38a58ebd:142d8456937:-7e", "");
        
        return "<br>" + "<br>" + llistaClasses + "<br>" + "<br>" + llistaInstancies + "<br>" + "<br>";
    }
    
    public String IntroduirInstanciaClasseCoordinates (String s, String individualCoordinates, OntModel ontmodel, String coordinates, String type){
        String str = "";
        String prefixClasse = "http://www.owl-ontologies.com/Ontology1380644855.owl";
        String prefixClasseN = prefixClasse + "#";
        String classeCoordinates = "Coordinates";
        
        OntClass coordinatesClass = ontmodel.getOntClass(prefixClasseN + classeCoordinates);
        Individual indivCoordinates = ontmodel.createIndividual(prefixClasseN+ individualCoordinates,coordinatesClass);
        
        OntProperty propCoordinates = ontmodel.getOntProperty(prefixClasseN + "coordinates");
        indivCoordinates.setPropertyValue(propCoordinates, ontmodel.createTypedLiteral(coordinates));
        
        OntProperty propType = ontmodel.getOntProperty(prefixClasseN + "type");
        indivCoordinates.setPropertyValue(propType, ontmodel.createTypedLiteral(type));
        
        str = str + "<br>" + "S'ha carregat la instancia " + individualCoordinates + " de la classe " + classeCoordinates + "<br>";
        return str;
    }
    
    public String IntroduirInstanciaClasseHashtag (String s, String individualHashtag, OntModel ontmodel, String indices, String text){
        String str = "";
        String prefixClasse = "http://www.owl-ontologies.com/Ontology1380644855.owl";
        String prefixClasseN = prefixClasse + "#";
        String classeHashtag = "Hashtag";
        
        OntClass hashtagClass = ontmodel.getOntClass(prefixClasseN + classeHashtag);
        Individual indivHashtag = ontmodel.createIndividual(prefixClasseN+ individualHashtag,hashtagClass);
        
        OntProperty propIndices = ontmodel.getOntProperty(prefixClasseN + "indices");
        indivHashtag.setPropertyValue(propIndices, ontmodel.createTypedLiteral(indices));
        
        OntProperty propText = ontmodel.getOntProperty(prefixClasseN + "text");
        indivHashtag.setPropertyValue(propText, ontmodel.createTypedLiteral(text));
        
        str = str + "<br>" + "S'ha carregat la instancia " + individualHashtag + " de la classe " + classeHashtag + "<br>";
        return str;
    }
    
    public String IntroduirInstanciaClasseMedia (String s, String individualMedia, OntModel ontmodel, String display_url){
        String str = "";
        String prefixClasse = "http://www.owl-ontologies.com/Ontology1380644855.owl";
        String prefixClasseN = prefixClasse + "#";
        String classeMedia = "Media";
        
        OntClass mediaClass = ontmodel.getOntClass(prefixClasseN + classeMedia);
        Individual indivMedia = ontmodel.createIndividual(prefixClasseN+ individualMedia,mediaClass);
        
        OntProperty propDisplay_url = ontmodel.getOntProperty(prefixClasseN + "display_url");
        indivMedia.setPropertyValue(propDisplay_url, ontmodel.createTypedLiteral(display_url));
        
        str = str + "<br>" + "S'ha carregat la instancia " + individualMedia + " de la classe " + classeMedia + "<br>";
        return str;
    }
    
    public String IntroduirInstanciaClasseUrl (String s, String individualUrl, OntModel ontmodel, String display_url){
        String str = "";
        String prefixClasse = "http://www.owl-ontologies.com/Ontology1380644855.owl";
        String prefixClasseN = prefixClasse + "#";
        String classeUrl = "Url";
        
        OntClass urlClass = ontmodel.getOntClass(prefixClasseN + classeUrl);
        Individual indivUrl = ontmodel.createIndividual(prefixClasseN+ individualUrl,urlClass);
        
        OntProperty propDisplay_url = ontmodel.getOntProperty(prefixClasseN + "display_url");
        indivUrl.setPropertyValue(propDisplay_url, ontmodel.createTypedLiteral(display_url));
        
        str = str + "<br>" + "S'ha carregat la instancia " + individualUrl + " de la classe " + classeUrl + "<br>";
        return str;
    }
    
    public String IntroduirInstanciaClasseUserMention (String s, String individualUserMention, OntModel ontmodel, String id){
        String str = "";
        String prefixClasse = "http://www.owl-ontologies.com/Ontology1380644855.owl";
        String prefixClasseN = prefixClasse + "#";
        String classeUserMention = "UserMention";
        
        OntClass userMentionClass = ontmodel.getOntClass(prefixClasseN + classeUserMention);
        Individual indivUserMention = ontmodel.createIndividual(prefixClasseN+ individualUserMention,userMentionClass);
        
        OntProperty propid = ontmodel.getOntProperty(prefixClasseN + "id");
        indivUserMention.setPropertyValue(propid, ontmodel.createTypedLiteral(id));
        
        str = str + "<br>" + "S'ha carregat la instancia " + individualUserMention + " de la classe " + classeUserMention + "<br>";
        return str;
    }
    
    public String IntroduirInstanciaClasseLlista (String s, String individualLlista, OntModel ontmodel, String description){
        String str = "";
        String prefixClasse = "http://www.owl-ontologies.com/Ontology1380644855.owl";
        String prefixClasseN = prefixClasse + "#";
        String classeLlista = "Llista";
        
        OntClass llistaClass = ontmodel.getOntClass(prefixClasseN + classeLlista);
        Individual indivLlista = ontmodel.createIndividual(prefixClasseN+ individualLlista,llistaClass);
        
        OntProperty propDescription = ontmodel.getOntProperty(prefixClasseN + "description");
        indivLlista.setPropertyValue(propDescription, ontmodel.createTypedLiteral(description));
        
        str = str + "<br>" + "S'ha carregat la instancia " + individualLlista + " de la classe " + classeLlista + "<br>";
        return str;
    }
    
    public String IntroduirInstanciaClasseSize (String s, String individualSize, OntModel ontmodel, String h, String resize, String w){
        String str = "";
        String prefixClasse = "http://www.owl-ontologies.com/Ontology1380644855.owl";
        String prefixClasseN = prefixClasse + "#";
        String classeSize = "Size";
        
        OntClass sizeClass = ontmodel.getOntClass(prefixClasseN + classeSize);
        Individual indivSize = ontmodel.createIndividual(prefixClasseN+ individualSize,sizeClass);
        
        OntProperty propH = ontmodel.getOntProperty(prefixClasseN + "h");
        indivSize.setPropertyValue(propH, ontmodel.createTypedLiteral(h));
        
        OntProperty propResize = ontmodel.getOntProperty(prefixClasseN + "resize");
        indivSize.setPropertyValue(propResize, ontmodel.createTypedLiteral(resize));
        
        OntProperty propW = ontmodel.getOntProperty(prefixClasseN + "w");
        indivSize.setPropertyValue(propW, ontmodel.createTypedLiteral(w));
        
        str = str + "<br>" + "S'ha carregat la instancia " + individualSize + " de la classe " + classeSize + "<br>";
        return str;
    }
    
    public String IntroduirInstanciaClasseSizes (String s, String individualSizes, OntModel ontmodel, String large){
        String str = "";
        String prefixClasse = "http://www.owl-ontologies.com/Ontology1380644855.owl";
        String prefixClasseN = prefixClasse + "#";
        String classeSizes = "Sizes";
        
        OntClass sizesClass = ontmodel.getOntClass(prefixClasseN + classeSizes);
        Individual indivSizes = ontmodel.createIndividual(prefixClasseN+ individualSizes,sizesClass);
        
        OntProperty propLarge = ontmodel.getOntProperty(prefixClasseN + "large");
        indivSizes.setPropertyValue(propLarge, ontmodel.createTypedLiteral(large));
        
        str = str + "<br>" + "S'ha carregat la instancia " + individualSizes + " de la classe " + classeSizes + "<br>";
        return str;
    }
    
    public String IntroduirInstanciaClasseTweet (String s, String individualTweet, OntModel ontmodel, String created_at){
        String str = "";
        String prefixClasse = "http://www.owl-ontologies.com/Ontology1380644855.owl";
        String prefixClasseN = prefixClasse + "#";
        String classeTweet = "Tweet";
        
        OntClass tweetClass = ontmodel.getOntClass(prefixClasseN + classeTweet);
        Individual indivTweet = ontmodel.createIndividual(prefixClasseN+ individualTweet,tweetClass);
        
        OntProperty propCreated_at = ontmodel.getOntProperty(prefixClasseN + "created_at");
        indivTweet.setPropertyValue(propCreated_at, ontmodel.createTypedLiteral(created_at));
        
        str = str + "<br>" + "S'ha carregat la instancia " + individualTweet + " de la classe " + classeTweet + "<br>";
        return str;
    }
    
    public String IntroduirInstanciaClasseUser (String s, String individualUser, OntModel ontmodel, String created_at){
        String str = "";
        String prefixClasse = "http://www.owl-ontologies.com/Ontology1380644855.owl";
        String prefixClasseN = prefixClasse + "#";
        String classeUser = "User";
        
        OntClass userClass = ontmodel.getOntClass(prefixClasseN + classeUser);
        Individual indivUser = ontmodel.createIndividual(prefixClasseN+ individualUser,userClass);
        
        OntProperty propCreated_at = ontmodel.getOntProperty(prefixClasseN + "created_at");
        indivUser.setPropertyValue(propCreated_at, ontmodel.createTypedLiteral(created_at));
        
        str = str + "<br>" + "S'ha carregat la instancia " + individualUser + " de la classe " + classeUser + "<br>";
        return str;
    }
    
}
